<?php

namespace Drupal\migrate_wizard\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\migrate_wizard\MWManageDataService;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * A controller to interact with origin node entities.
 */
class OriginNodeController extends ControllerBase {

  /**
   * The MWManageDataService.
   *
   * @var \Drupal\migrate_wizard\MWManageDataService
   */
  protected $mwManageDataService;

  /**
   * {@inheritdoc}
   */
  public function __construct(MWManageDataService $mw_manage_data_service) {
    $this->mwManageDataService = $mw_manage_data_service;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new self(
      $container->get('migrate_wizard.migrate_wizard_manage_data_service'),
    );
  }

  /**
   * {@inheritdoc}
   */
  public function readOriginNodes() {
    $this->mwManageDataService->readOriginNodes();

    $this->messenger()
      ->addStatus($this->t('Completed discovery for Origin Nodes.'));
    return $this->redirect('entity.origin_node.list');
  }

  /**
   * {@inheritdoc}
   */
  public function clearOriginNodes() {
    $this->mwManageDataService->clearOriginNodes();

    $this->messenger()
      ->addStatus($this->t('Completed clear Origin Nodes.'));
    return $this->redirect('entity.origin_node.list');
  }

}
