<?php

namespace Drupal\migrate_wizard\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\migrate_wizard\MWManageDataService;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * A controller to interact with origin vocabulary entities.
 */
class OriginVocabularyController extends ControllerBase {

  /**
   * The MWManageDataService.
   *
   * @var \Drupal\migrate_wizard\MWManageDataService
   */
  protected $mwManageDataService;

  /**
   * {@inheritdoc}
   */
  public function __construct(MWManageDataService $mw_manage_data_service) {
    $this->mwManageDataService = $mw_manage_data_service;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new self(
      $container->get('migrate_wizard.migrate_wizard_manage_data_service'),
    );
  }

  /**
   * {@inheritdoc}
   */
  public function readOriginVocabularies() {
    $this->mwManageDataService->readOriginVocabularies();

    $this->messenger()
      ->addStatus($this->t('Completed discovery for Origin Vocabularies.'));
    return $this->redirect('entity.origin_vocabularies.list');
  }

  /**
   * {@inheritdoc}
   */
  public function clearOriginVocabularies() {
    $this->mwManageDataService->clearOriginVocabularies();

    $this->messenger()
      ->addStatus($this->t('Completed clear Origin Vocabularies.'));
    return $this->redirect('entity.origin_vocabularies.list');
  }

}
