<?php

namespace Drupal\migrate_wizard\Entity;

use Drupal\Core\Config\Entity\ConfigEntityBase;

/**
 * Defines the Migration Group entity.
 *
 * The migration group entity is used to group active migrations, as well as to
 * store shared migration configuration.
 *
 * @ConfigEntityType(
 *   id = "origin_paragraph",
 *   label = @Translation("Origin Paragraph"),
 *   handlers = {
 *     "list_builder" = "Drupal\migrate_wizard\Controller\OriginParagraphListBuilder",
 *   },
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label"
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *     "source_type",
 *     "module",
 *     "shared_configuration",
 *   }
 * )
 */
class OriginParagraph extends ConfigEntityBase implements OriginParagraphInterface {


}
