<?php

namespace Drupal\migrate_wizard;

use Drupal\Core\Config\Config;
use Drupal\Core\Config\ConfigFactoryInterface;
use Drupal\Core\Database\Query\SelectInterface;
use Drupal\Core\Entity\EntityFieldManagerInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Plugin\PluginBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\State\StateInterface;
use Drupal\migrate\Plugin\migrate\source\SqlBase;
use Drupal\migrate\Plugin\MigrationInterface;
use Drupal\migrate_wizard\Plugin\migrate\source\Wildcard;
use Drupal\mysql\Driver\Database\mysql\Select;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Base class for FieldType plugins.
 */
abstract class FieldTypeMWBase {

  public static function getMWDatabase($mw_database) {

    return \Drupal::service('entity_type.manager')->getStorage('mw_database')->load($mw_database);

  }

  /**
   * {@inheritdoc}
   */
  public static function insertBeforeKey($originalArray, $originalKey, $insertKey, $insertValue) {

    $newArray = [];
    $inserted = FALSE;
    foreach ($originalArray as $key => $value) {
      if (!$inserted && $key === $originalKey) {
        if(!isset($newArray[$insertKey])){
          $newArray[$insertKey] = [$insertValue];
        }else{
          $newArray[$insertKey][] = $insertValue;
        }
        $inserted = TRUE;
      }
      $newArray[$key] = $value;
    }
    return $newArray;
  }
}
