<?php

namespace Drupal\migrate_wizard;

use Drupal\Core\Entity\ContentEntityInterface;

/**
 * Provides an interface defining a origin_content_type entity.
 */
interface OriginContentTypesInterface extends ContentEntityInterface {

  /**
   * Gets the source label.
   *
   * @return string
   *   The source label.
   */
  public function getLabel();

  /**
   * Gets the source description.
   *
   * @return string
   *   The source description.
   */
  public function getDescription();

  /**
   * Gets the source id_content_type.
   *
   * @return string
   *   The source id_content_type.
   */
  public function getIdContentType();

}
