<?php

namespace Drupal\migrate_wizard\Plugin\Derivative;

use Drupal\migrate_wizard\Plugin\migrate\destination\MWEntityReferenceRevisions;
use Drupal\migrate\Plugin\Derivative\MigrateEntityRevision;

/**
 * Class MWMigrateEntityReferenceRevisions
 */
class MWMigrateEntityReferenceRevisions extends MigrateEntityRevision  {

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($basePluginDefinition) {
    foreach ($this->entityDefinitions as $entityType => $entityInfo) {
      if ($entityInfo->getKey('revision')) {
        $this->derivatives[$entityType] = [
          'id' => "entity_reference_revisions:$entityType",
          'class' => MWEntityReferenceRevisions::class,
          'requirements_met' => 1,
          'provider' => $entityInfo->getProvider(),
        ];
      }
    }
    return $this->derivatives;
  }

}
