<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'generic_file' field type.
 *
 * @FieldType(
 *   id = "generic_file",
 * )
 */
class FieldTypeMWGenericFile extends FieldTypeMWBase {
  public static function getD7MigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $langcode = NULL) {

    if($type_source == 'taxonomy_term' && $langcode != NULL){
      return true;
    }
    $fields_content_type_destiny = $entityFieldManager->getFieldDefinitions($type_source, $wildcard_yml_config["process"]["type"]["default_value"]);
    $settings_field = $fields_content_type_destiny[$data_field['destiny']]->getSettings();
    $array_config = [];
    if(count($settings_field['handler_settings']) > 0){
      if(!isset($wildcard_yml_config['process'][$data_field['destiny']])){

        $array_config['pseudo_'.$origin_field][] = [
          'plugin' => 'get_file',
          'source' => $origin_field,
        ];
        $array_config['pseudo_'.$origin_field][] = [
          'plugin' => 'create_media',
          'entity_type' => 'media',
          'bundle' => $data_field["media_type"],
          'field_name' => $data_field["media_field"],
        ];
        $array_config['pseudo_'.$data_field['destiny']][] = [
            'plugin' => 'media_concat_data',
            'source' => ['@pseudo_'.$origin_field],
        ];
        $array_config[$data_field['destiny']][] = [
          'plugin' => 'sub_process',
          'source' => '@pseudo_'.$data_field['destiny'],
          'method' => 'process',
          'process' => ['target_id' => 'mid'],
        ];
      }else{
        $insert_value = [
          'plugin' => 'get_file',
          'source' => $origin_field,
        ];
        $wildcard_yml_config['process'] = parent::InsertBeforeKey($wildcard_yml_config['process'], 'pseudo_'.$data_field['destiny'], 'pseudo_'.$origin_field, $insert_value);
        $insert_value = [
          'plugin' => 'create_media',
          'entity_type' => 'media',
          'bundle' => $data_field["media_type"],
          'field_name' => $data_field["media_field"],
        ];
        $wildcard_yml_config['process'] = parent::InsertBeforeKey($wildcard_yml_config['process'], 'pseudo_'.$data_field['destiny'], 'pseudo_'.$origin_field, $insert_value);
        $wildcard_yml_config['process']['pseudo_'.$data_field['destiny']][0]['source'][] = '@pseudo_'.$origin_field;
      }
    }else{
      if(!isset($wildcard_yml_config['process'][$data_field['destiny']])){
        $array_config['pseudo_'.$origin_field][] = [
          'plugin' => 'skip_on_empty',
          'source' => $origin_field,
          'method' => 'process',
        ];
        $array_config['pseudo_'.$origin_field][] = [
          'plugin' => 'get_file'
        ];
        $array_config['pseudo_'.$data_field['destiny']][] = [
            'plugin' => 'media_concat_data',
            'source' => ['@pseudo_'.$origin_field],
        ];
        if ($data_field['type'] == 'image') {
          $array_config[$data_field['destiny']][] = [
            'plugin' => 'sub_process',
            'method' => 'process',
            'source' => '@pseudo_'.$data_field['destiny'],
            'process' => [
              'target_id' => 'target_id',
              'alt' => 'alt',
              'title' => 'title'
            ],
          ];
        }
        elseif ($data_field['type'] == 'file') {
          $array_config[$data_field['destiny']][] = [
            'plugin' => 'sub_process',
            'method' => 'process',
            'process' => [
              'target_id' => 'target_id',
              'description' => 'description',
            ],
          ];
        }
      }else{
        $insert_value = [
          'plugin' => 'skip_on_empty',
          'source' => $origin_field,
          'method' => 'process',
        ];
        $wildcard_yml_config['process'] = parent::InsertBeforeKey($wildcard_yml_config['process'], 'pseudo_'.$data_field['destiny'], 'pseudo_'.$origin_field, $insert_value);
        $insert_value = [
          'plugin' => 'get_file'
        ];
        $wildcard_yml_config['process'] = parent::InsertBeforeKey($wildcard_yml_config['process'], 'pseudo_'.$data_field['destiny'], 'pseudo_'.$origin_field, $insert_value);
        $wildcard_yml_config['process']['pseudo_'.$data_field['destiny']][0]['source'][] = '@pseudo_'.$origin_field;
      }
    }
    $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
  }

  public function addQueryByType($alias, $table, $data_field, $wildcard, $translation, $field_collection = NULL): void {
    $base_field = str_replace('field_data_', '', $table);
    $talias = $alias . '_file';
    $wildcard->query->leftJoin('file_managed', $talias, "$alias.{$base_field}_fid = $talias.fid");
    $wildcard->query->fields($talias, ['uri']);
  }
}
