<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\field\Entity\FieldStorageConfig;
use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'range' field type.
 *
 * @FieldType(
 *   id = "range",
 * )
 */
class FieldTypeMWGenericRange extends FieldTypeMWBase {

  public static function getD7MigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $langcode = NULL): void {

    $array_config[$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => [$origin_field . '_from', $origin_field . '_to'],
      'method' => 'process',
    ];
    $array_config[$data_field['destiny']][] = [
      'plugin' => 'format_range_explode',
    ];

    $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
  }
}
