<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\field\Entity\FieldStorageConfig;
use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'geofield' field type.
 *
 * @FieldType(
 *   id = "geofield",
 * )
 */
class FieldTypeMWGeofield extends FieldTypeMWBase {

  public static function getD7MigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $langcode = NULL): void {

    $array_config[$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => $origin_field,
      'method' => 'process',
    ];
    $array_config[$data_field['destiny']][] = [
      'plugin' => 'sub_process',
      'process' => [
        'lat' => 'lat',
        'lon' => 'lon',
        'left' => 'left',
        'top' => 'top',
        'right' => 'right',
        'bottom' => 'bottom',
        'geohash' => 'geohash',
        'value' => [
          'plugin' => 'geofield_point',
          'source' => ['lon', 'lat'],
        ]
      ]
    ];

    $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
  }
}
