<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'paragraphs' field type.
 *
 * @FieldType(
 *   id = "paragraphs",
 * )
 */
class FieldTypeMWParagraphs extends FieldTypeMWBase {

  public static function getD7MigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $paragraph = NULL): void {

    $destiny_explode = explode('/', $data_field['destiny']);
    $array_config[$destiny_explode[0]][] = [
      'plugin' => 'skip_on_empty',
      'method' => 'process',
      'source' => $origin_field,
    ];

    foreach($data_field["bundle"] as $bundle){
      $array_config[$destiny_explode[0]][] = [
        'plugin' => 'migration_lookup',
        'migration' => $bundle,
        'no_stub' => true,
      ];
    }
    $array_config[$destiny_explode[0]][] = [
      'plugin' => 'sub_process',
      'process' => ['target_id' => '0', 'target_revision_id' => '1'],
    ];

    $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
    $wildcard_yml_config['migration_dependencies']['required'][] = $origin_field;
  }
}
