<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\field\Entity\FieldStorageConfig;
use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'workbench_access_node' field type.
 *
 * @FieldType(
 *   id = "workbench_access_node",
 * )
 */
class FieldTypeMWWorkbenchAccessNode extends FieldTypeMWBase {

  public static function getMigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $field_collection = NULL): void {

    $wildcard_yml_config['process'][$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => 'access_id',
      'method' => 'process',
    ];
    $wildcard_yml_config['process'][$data_field['destiny']][] = [
      'plugin' => 'migration_lookup',
      'migration' => $data_field["migration_lookup"],
      'no_stub' => TRUE,
    ];
    $wildcard_yml_config['migration_dependencies']['required'][] = $data_field["migration_lookup"];
  }

  public function addQueryByType($alias, $table, $data_field, $wildcard, $translation): void {
    $wildcard->query->leftJoin('workbench_access_node', 'workbench_access_node', "{$wildcard->getValue('leftJoinTable')} = workbench_access_node.nid");
    $wildcard->query->fields('workbench_access_node', ['access_id']);
    $wildcard->query->groupBy('access_id');
  }
}
