<?php

namespace Drupal\migrate_wizard\Plugin\migrate\process;

use Drupal\media\Entity\Media;
use Drupal\migrate\ProcessPluginBase;
use Drupal\migrate\MigrateExecutableInterface;
use Drupal\migrate\Row;
use Drupal\paragraphs\Entity\Paragraph;
use Drupal\Core\Entity\EntityFieldManagerInterface;


/**
 * Create media.
 *
 * @MigrateProcessPlugin(
 *   id = "create_paragraph_entity"
 * )
 */
class CreateParagraphEntity extends ProcessPluginBase {

  /**
   * {@inheritdoc}
   */
  protected $config;

  /**
   * {@inheritdoc}
   */
  protected $migrationUrlFilesProd;

  /**
   * {@inheritdoc}
   */
  protected $fileSystem;

  /**
   * {@inheritdoc}
   */
  protected $entityManager;

  /**
   * {@inheritdoc}
   */
  protected $entityFieldManager;

  /**
   * {@inheritdoc}
   */
  public function transform($value, MigrateExecutableInterface $migrate_executable, Row $row, $destination_property) {
    $this->config = \Drupal::configFactory()->getEditable('migrate_wizard.settings');
    $this->entityManager = \Drupal::service('entity_type.manager');
    $this->entityFieldManager = \Drupal::service('entity_field.manager');

    $values_array_by_id_paragraph = [];
    $values_null_by_id_paragraph = [];

    $key_value = 0;
    foreach ($value as $key => $val) {
      if($val == null){
        $values_null_by_id_paragraph[$key][] = null;
        continue;
      }

      foreach($val as $value_value){
        if(is_array($value_value) && isset($value_value['id_parent'])){

//          $array_values = [];
//          foreach($value_value as $key_value_array => $value_value_array){
//
//          }

          $values_array_by_id_paragraph[$value_value['id_parent']][$key][] = $value_value;
          $key_value++;
          continue;
        }
        $tmp_value = [];
        if(is_array($value_value)){
          foreach($value_value as $key_value_array => $value_value_array){

            if($value_value_array == ''){
              continue;
            }

            $tmp_explode_value = explode('¬¬', $value_value_array);
            $tmp_value[$key_value_array] = $tmp_explode_value[0];
          }
          $values_array_by_id_paragraph[$tmp_explode_value[1]][$key][] = $tmp_value;
          $values_array_by_id_paragraph[$tmp_explode_value[1]]['id_parent'] = $tmp_explode_value[2];
          continue;
        }
        if(!str_contains($value_value, '¬¬')){
          continue;
        }else{
          $tmp_explode_value = explode('¬¬', $value_value);
          $values_array_by_id_paragraph[$tmp_explode_value[1]][$key_value][] = $tmp_explode_value[0];
          $values_array_by_id_paragraph[$tmp_explode_value[1]]['id_parent'] = $tmp_explode_value[2];
        }

      }
      $key_value++;
    }

    foreach($values_null_by_id_paragraph as $key_null => $val_null){
      foreach($values_array_by_id_paragraph as $key_array => $val_array){
        $values_array_by_id_paragraph[$key_array][$key_null] = null;
        ksort($values_array_by_id_paragraph[$key_array]);
      }
    }

//    $id_parent = $values_array_by_id_paragraph['id_parent'];
//    unset($values_array_by_id_paragraph['id_parent']);
////    $values_array_by_id_paragraph = array_values($values_array_by_id_paragraph);
//    $values_array_by_id_paragraph['id_parent'] = $id_parent;
//    $values_array_by_id_paragraph = array_map('array_values', $values_array_by_id_paragraph);

//    foreach($values_array_by_id_paragraph as $key => &$value_array_by_id_paragraph_ordered){
//      $id_parent = $value_array_by_id_paragraph_ordered['id_parent'];
//      unset($value_array_by_id_paragraph_ordered['id_parent']);
//      $value_array_by_id_paragraph_ordered = array_values($value_array_by_id_paragraph_ordered);
//      $value_array_by_id_paragraph_ordered['id_parent'] = $id_parent;
//    }






    $base_fields = $this->entityFieldManager->getFieldDefinitions('paragraph', null);
    $paragraph_fields = $this->entityFieldManager->getFieldDefinitions('paragraph', $this->configuration['bundle']);
    $paragraph_fields = array_diff_key($paragraph_fields, $base_fields);

    foreach($paragraph_fields as $field_name => $field_config){
      if(!in_array('@pseudo_' . $field_name, $this->configuration["source"])){
        unset($paragraph_fields[$field_name]);
      }
    }

    $array_creation_paragraph = ['paragraph_type' => $this->configuration["bundle"]];
    $configuration_source = $this->configuration["source"];
    $key_int = 0;

    foreach($values_array_by_id_paragraph as $key_value_array_by_id => $value_array_by_id_paragraph){

      foreach($paragraph_fields as $field_name => $field_config){
        if(isset($configuration_source[$key_int]) && $field_name == str_replace('@pseudo_', '', $configuration_source[$key_int])){
          $field_schema = $field_config->getFieldStorageDefinition()->getSchema();
          if(isset($value_array_by_id_paragraph[$key_int])){
            foreach($value_array_by_id_paragraph[$key_int] as $key_value => $value_value){
              if(is_array($value_value)){
                $array_value_value_array = [];



                foreach($value_value as $key_value_array => $value_value_array){
                  if(isset($field_schema['columns'][$key_value_array])){
                    $array_value_value_array[$key_value_array] = $value_value_array;
                  }
                }
                $array_creation_paragraph[$key_value_array_by_id]['fields'][$field_name][] = $array_value_value_array;
              }else{
                $array_creation_paragraph[$key_value_array_by_id]['fields'][$field_name][] = $value_value;
                $array_creation_paragraph[$key_value_array_by_id]['id_parent'] = $value_array_by_id_paragraph['id_parent'];
              }
            }
          }
        }
        $key_int++;
      }
      $key_int = 0;
    }

    $new_values = [];
    foreach($array_creation_paragraph as $key => $data_paragraph){
      if($key != 'paragraph_type'){
        $new_values[] = $this->createParagraph(['paragraph_type' => $array_creation_paragraph['paragraph_type'], 'fields' => $data_paragraph['fields'], 'id_parent' => $data_paragraph['id_parent']]);
      }
    }
    return $new_values;
  }

  protected function createParagraph($array_creation_paragraph){

    $paragraph = Paragraph::create([
      'type' => $array_creation_paragraph['paragraph_type']
    ]);

    foreach($array_creation_paragraph['fields'] as $key => $value){
//      if(is_array($value)){
//        foreach($value as $key_value => $value_value){
//          $paragraph->set($key, $value_value);
//        }
//      }else{
        $paragraph->set($key, $value);
//      }
    }
    $paragraph->save();
    return [$paragraph->id(), $paragraph->getRevisionId(), $array_creation_paragraph['id_parent']];
  }

}
